---
feature_story: FS_14_59_14_06
feature_title: pending requests
feature_status: TEST
---

This feature splits client into two OS processes:
*   parent to control user interaction
*   child to wait for pending request

The initial motivation was to provide indication (spinner) of long-running request to the user.

# Spinner

The spinner is only used for:
*   `ServerAction.ProposeArgValues` = Tab
*   `ServerAction.DescribeLineArgs` = Alt+Shift+Q
Specifically, `ServerAction.RelayLineArgs` simply blocks within the same OS process until requests completes.

The current implementation relies on the following split in responsibilities:
*   Instead of terminal output, a child writes its stdout into a pipe for a parent.
*   The parent waits for the child to complete, then it prints the contents of the pipe into stdout (terminal).
*   The parent uses stderr (terminal) to update pending request indicator.

This way, while waiting for a child to complete, a parent can print anything to the terminal via stderr
without conflict and interleaving characters.

Technically, using the extra pipe between parent and child is
only required for `ServerAction.DescribeLineArgs` = Alt+Shift+Q because
Bash already captures stdout for `ServerAction.ProposeArgValues` = Tab requests until client completes.
But, for simplicity and uniform implementation, both requests are implemented the same way.

TODO: The spinner is disabled by default (require test support for End2End tests where configs are not mocked).
      To enable it, use  `ClientConfig.show_pending_spinner`
